<template>
  <div class="mod-config" style="height:100%;">
    <div class="avue-crud" style="width: 100%;height:100%;">
      <div style="display:flex;height:100%;">
        <div style="width:35%;padding-left:20px;">
          <div style="margin-bottom:20px;margin-top:50px;">
            <div style="color:red;font-weight:bold;margin-bottom:5px;">
              中兴合格证二维码：
            </div>
            <div>
              <el-input
                ref="pkg_no_input"
                v-focus
                v-model="pkgNo"
                @keyup.enter.native="jumpToMaoZhong"
              ></el-input>
            </div>
          </div>

          <div style="margin-bottom:20px;">
            <div style="color:red;font-weight:bold;margin-bottom:5px;">
              毛重：
            </div>
            <div style="display:flex;justify-content:space-between;">
              <div style="width:70%">
                <el-input ref="maozhong_input" v-model="grossWeight"></el-input>
              </div>
              <div style="width:20%">
                <el-button round @click="autoWeigh">自动称重</el-button>
              </div>
            </div>
          </div>
          <div
            style="display:flex;justify-content:space-around;margin-top:50px;"
          >
            <div style="text-align:center;">
              <el-button round @click="submit">提交</el-button>
            </div>
            <div style="text-align:center;">
              <el-button round @click="clearContent">清除</el-button>
            </div>
          </div>
        </div>
        <div style="width:60%;padding-top:20px;">
          <ttable
            :table="table"
            :uploadInfo="uploadInfo"
            :prelang="prelang"
            :options="options"
            :bottomOffset="40"
            :ajaxFun="ajaxFun"
            ref="weightlabelTable"
          >
            <template #toolbar></template>
          </ttable>
        </div>
      </div>
    </div>
    <weightlabelFormDialog
      :currshowlist.sync="showWeightLabelForm"
      :formInfo="formInfo"
      @refreshWeightList="refreshWeightList"
    />
  </div>
</template>
<script>
import ttable from '@/views/common/ztt-table.vue'
import {
  addObj,
  fetchList,
  delZxWeightlabel,
  getWeighing
} from '@/api/zte/zxweightlabel'
import getLodop from '@/util/lodop'
import { mapGetters } from 'vuex'
import weightlabelFormDialog from './weightlabel-form'
export default {
  data() {
    return {
      ajaxFun: fetchList,
      uploadInfo: {
        // 是否展示上传EXCEL以及对应的url
        isShow: false,
        url: ''
      },
      prelang: 'weightlabel',
      options: {
        height: 300, // 默认高度-为了表头固定
        stripe: true, // 是否为斑马纹 table
        highlightCurrentRow: false, // 是否要高亮当前行
        border: true, // 是否有纵向边框
        lazy: false, // 是否需要懒加载
        fit: true, // 列的宽度是否自撑开
        multiSelect: true, //
        seqNo: true,
        isShowHide: true, // 是否显示显影按钮
        isRefresh: true,
        isSearch: false, // 高级查询按钮
        defaultOrderBy: { column: 'id', direction: 'desc' }
      },
      table: {
        total: 0,
        currentPage: 1,
        pageSize: 20,
        data: [],
        // 标题
        column: [
          // pkg条码
          {
            minWidth: '30',
            prop: 'pkgCode',
            label: 'pkg条码',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          // 物料编号
          {
            minWidth: '140',
            prop: 'materialCode',
            label: '物料编号',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          // 长度
          {
            minWidth: '120',
            prop: 'quantity',
            label: '长度',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },

          // 包装尺寸
          {
            minWidth: '140',
            prop: 'packSize',
            label: '包装尺寸',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          // 包装材质
          {
            minWidth: '140',
            prop: 'packMaterial',
            label: '包装材质',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          // 包材重量
          {
            minWidth: '140',
            prop: 'packWeight',
            label: '包材重量',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          // 毛重
          {
            minWidth: '140',
            prop: 'grossWeight',
            label: '毛重',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          // 净重
          {
            minWidth: '140',
            prop: 'netWeight',
            label: '净重',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          // 创建人
          {
            minWidth: '120',
            prop: 'createUser',
            label: '创建人',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'text'
          },
          {
            minWidth: '200',
            prop: 'createTime',
            label: '创建时间',
            sort: true,
            isTrue: true,
            isSearch: true,
            searchInfoType: 'datetimerange'
          }
        ],
        toolbar: [],
        operator: [
          {
            text: '删除',
            type: 'text',
            size: 'small',
            fun: this.deleteHandle
          },
          {
            text: '打印',
            type: 'text',
            size: 'small',
            fun: this.printHandle
          }
        ],
        operatorConfig: {
          fixed: 'right',
          label: '操作',
          width: 120,
          minWidth: 120
        }
      },
      grossWeight: null,
      pkgNo: null,
      bottomOffset: 20,
      fixedHeight: 0,
      showWeightLabelForm: false,
      formInfo: null
    }
  },
  components: {
    ttable,
    weightlabelFormDialog
  },

  computed: {
    ...mapGetters(['permissions'])
  },
  directives: {
    focus: {
      inserted: function(el, option) {
        var defClass = 'el-input'
        var defTag = 'input'
        var value = option.value || true
        if (typeof value === 'boolean')
          value = { cls: defClass, tag: defTag, foc: value }
        else
          value = {
            cls: value.cls || defClass,
            tag: value.tag || defTag,
            foc: value.foc || false
          }
        // if (el.classList.contains(value.cls) && value.foc)
        el.getElementsByTagName(value.tag)[0].focus()
      }
    }
  },
  mounted() {
    this.$nextTick(() => {
      this.$refs.pkg_no_input.focus()
    })
  },
  methods: {
    jumpToMaoZhong() {
      this.$refs.maozhong_input.focus()
    },
    autoWeigh() {
      getWeighing()
        .then((response) => {
          const resData = response.data
          this.grossWeight = resData.data
        })
        .catch(() => {
          this.grossWeight = null
        })
    },
    submit() {
      if (this.pkgNo != null && this.pkgNo.trim() != '') {
      } else {
        this.$message.error('pkg码不能为空')
        return
      }
      if (this.grossWeight != null && this.grossWeight.trim() != '') {
        if (isNaN(Number(this.grossWeight))) {
          this.$message.error('毛重必须为纯数字')
          return
        } else {
          if (Number(this.grossWeight.trim()) <= 0) {
            this.$message.error('毛重必须大于0')
            return
          }
        }
      } else {
        this.$message.error('毛重不能为空')
        return
      }
      const paramObj = {
        pkgCode: this.pkgNo.trim(),
        grossWeight: this.grossWeight.trim(),
        shopCode: 'GD'
      }
      addObj(paramObj).then((response) => {
        const resData = response.data
        if (resData.data.popWindow) {
          // 弹出弹窗，填写“包装尺寸”、“包装重量”及“包装材料”
          this.showWeightLabelForm = true
          this.formInfo = {
            pkgNo: this.pkgNo,
            grossWeight: this.grossWeight
          }
        } else {
          this.refreshWeightList()
          this.$message.success('提交成功')
        }
      })
    },
    clearContent() {
      this.grossWeight = null
      this.pkgNo = null
      this.$refs.pkg_no_input.focus()
    },
    deleteHandle(row) {
      delZxWeightlabel([row.id]).then((response) => {
        this.$message.success('删除成功')
        this.getData()
      })
    },
    printHandle(row) {
      this.LODOP = getLodop()
      const grossWeight = Number(row.grossWeight).toFixed(2)
      const netWeight = Number(row.netWeight).toFixed(2)
      const qrStr =
        grossWeight +
        '*' +
        netWeight +
        '*' +
        row.packSize +
        '*' +
        row.materialCode

      this.LODOP.SET_LICENSES(
        '南通市鑫阳软件开发有限公司',
        '60F8E5078AE17DEB340C94BC7E83CAFF',
        '',
        ''
      )
      this.LODOP.PRINT_INITA(0, 0, 420, 300, '')
      this.LODOP.SET_PRINT_PAGESIZE(0, 700, 500, '')
      this.LODOP.SET_PRINT_MODE('PRINT_NOCOLLATE', 1)
      this.LODOP.ADD_PRINT_BARCODE(90, 163, 100, 100, 'QRCode', qrStr)
      this.LODOP.SET_PRINT_STYLEA(0, 'QRCodeVersion', 7)
      this.LODOP.SET_PRINT_STYLEA(0, 'QRCodeErrorLevel', 'L')
      this.LODOP.ADD_PRINT_TEXT(10, 8, 50, 20, 'P/N：')
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 11)
      this.LODOP.ADD_PRINT_TEXT(40, 8, 120, 20, '尺寸OD（MM）：')
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 11)
      this.LODOP.ADD_PRINT_TEXT(70, 8, 120, 20, '毛重GW（KG）：')
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 11)
      this.LODOP.ADD_PRINT_TEXT(100, 8, 120, 20, '净重NW（KG）：')
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 11)
      this.LODOP.ADD_PRINT_TEXT(130, 8, 120, 20, '数量（M）：')
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 11)
      this.LODOP.ADD_PRINT_TEXT(160, 8, 55, 20, '包材：')
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 11)

      this.LODOP.ADD_PRINT_TEXT(10, 45, 150, 20, row.materialCode)
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 11)
      this.LODOP.ADD_PRINT_TEXT(40, 105, 150, 20, row.packSize)
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 11)
      this.LODOP.ADD_PRINT_TEXT(70, 105, 150, 30, grossWeight)
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 11)
      this.LODOP.ADD_PRINT_TEXT(100, 105, 95, 20, netWeight)
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 11)
      this.LODOP.ADD_PRINT_TEXT(130, 95, 95, 20, row.quantity)
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 11)
      this.LODOP.ADD_PRINT_TEXT(160, 50, 95, 20, row.packMaterial)
      this.LODOP.SET_PRINT_STYLEA(0, 'FontSize', 11)

      // this.LODOP.PREVIEW()
      this.LODOP.PRINT()
    },
    getData() {
      return this.$refs.weightlabelTable.getDataList()
    },
    refreshWeightList() {
      this.getData()
    }
  }
}
</script>
<style lang="scss" scoped>
.bind-input-class {
  height: 0px;
}
.bind-input-class >>> .el-input__inner {
  height: 0px;
  border: 0px solid #ddd;
}
.clear-input-class {
  height: 0px;
}
.clear-input-class >>> .el-input__inner {
  height: 0px;
  border: 0px solid #ddd;
}
.clear-focus-btn-class.el-button {
  color: #006eff;
  border-color: #b3d4ff;
  background-color: #e6f1ff;
}
.clear-btn-class {
  color: #606266;
  border-color: #dcdfe6;
  background-color: #fff;
}
.bind-focus-btn-class {
  color: #006eff;
  border-color: #b3d4ff;
  background-color: #e6f1ff;
}
.bind-btn-class {
  color: #606266;
  border-color: #dcdfe6;
  background-color: #fff;
}
</style>
